<?php
/**
 * @package Fotocash
 */
/*
Plugin Name: Fotocash
Plugin URI: http://fotocash.ru/
Description: Виджет знакомств от партнерской программы Fotocash.ru
Version: 0.4
Author: Fotocash.ru
Author URI: http://fotocash.ru/promo/plugins/wordpress
License: GPLv2 or later
*/


/**
 * Adds Fotocash_Widget widget.
 */
class Fotocash_Widget extends WP_Widget {

	private $_tds_url = 'http://fotostrana.ru/go.php';
	private $_exteranl_api = 'http://fotostrana.ru/fast/start_widget.php';
	private $_tds_promo = 20519;
	private static $_initied = 0;

	private $_fields = array(
		'title' => array(
			'label' => 'Title:',
			'default' => 'Быстрые знакомства',
		),
		'ref_id' => array(
			'label' => 'Субаккаунт:',
			'validator' => 'valid_ref_id',
			'required' => true,
			'tip' => '<a href="http://fotocash.ru/signup" target="_blank">Регистрация</a>',
		),
		'sub_id' => array(
			'label' => 'SubID:',
			'validator' => 'valid_sub_id',
		),
		'format' => array(
			'label' => 'Размещение:',
			'default' => 'v',
			'values' => array(
				'v' => 'Вертикальный',
				'g' => 'Горизонтальный',
			),
			'tip' => '<strong>Вертикальный</strong> вариант формы подходит для блоков шириной <strong>до 360px</strong>,
					все поля ввода в этом представлении формы располагаются друг под другом.<br />
				<strong>Горизонтальный</strong> вариант оптимален для блоков шириной <strong>более 360px</strong>,
					поля ввода расположены в два ряда.',
		),
		'color_button' => array(
			'label' => 'Цвет кнопки:',
			'default' => 'blue',
			'values' => array(
				'' => 'Серый',
				'red' => 'Красный',
				'orange' => 'Оранжевый',
				'blue' => 'Синий',
				'green' => 'Зеленый',
			),
		),
		'gender' => array(
			'label' => 'Искать по-умолчанию:',
			'default' => 'f',
			'values' => array(
				'm' => 'Парня',
				'f' => 'Девушку',
			),
		),
		'age' => array(
			'label' => 'Возраст по-умолчанию от:',
			'validator' => 'valid_age',
			'default' => 18,
		),
		'age_to' => array(
			'label' => 'Возраст по-умолчанию до:',
			'validator' => 'valid_age',
			'default' => 30,
		),
		'city' => array(
			'label' => 'Город:',
			'default' => 0,
			'values' => array(
				0 => 'Не важно',
				1 => 'Москва',
				2 => 'Санкт-Петербург',
				8 => 'Киев',
				43 => 'Минск',
				9 => 'Харьков',
				33 => 'Алматы',
				34 => 'Астана',
				44 => 'Гомель',
				3 => 'Новосибирск',
				10 => 'Днепропетровск',
				37 => 'Шымкент',
				45 => 'Могилёв',
				4 => 'Екатеринбург',
				11 => 'Донецк',
				36 => 'Караганда',
				46 => 'Витебск',
				5 => 'Нижний Новгород',
				6 => 'Самара',
				7 => 'Омск',
				187 => 'Лондон',
				233 => 'Париж',
				267 => 'Хельсинки',
				578 => 'Пекин',
				1201 => 'Сеул',
				2659 => 'Брюссель',
				119 => 'Баку',
				148 => 'Анкара',
				157 => 'Дубай',
				160 => 'Ереван',
				163 => 'Дакар',
				169 => 'Берлин',
				175 => 'Вильнюс',
				208 => 'Тбилиси',
				312 => 'Торонто',
				370 => 'Бишкек',
				433 => 'Кабул',
				505 => 'Кишинев',
				520 => 'Римини',
				529 => 'Турин',
			),
			'tip' => 'Оставьте <strong>Не важно</strong> для автоматического определения города',
		),
		'color_bg' => array(
			'label' => 'Цвет фона формы:',
			'validator' => 'valid_color',
			'tip' => 'По-умолчанию будет использоваться цвет установленной темы',
		),
		'color_border' => array(
			'label' => 'Цвет границы формы:',
			'validator' => 'valid_color',
			'tip' => 'Оставьте пустым, чтобы использовать цвет установленной темы',
		),
		'color_title' => array(
			'label' => 'Цвет заголовка:',
			'validator' => 'valid_color',
			'tip' => 'По-умолчанию будет использоваться стиль установленной темы',
		),
		'color_text' => array(
			'label' => 'Цвет шрифта:',
			'validator' => 'valid_color',
			'tip' => 'По-умолчанию будет использоваться цвет установленной темы',
		),
		'show_custom' => array(
			'label' => 'Дополнительные параметры:',
			'default' => 0,
			'values' => array('Нет', 'Да'),
			'tip' => 'Отображение дополнительных параметры поиска',
		),
	);

	/**
	 * Register widget with WordPress.
	 */
	public function __construct() {
		parent::__construct(
	 		'fotocash', // Base ID
			'Fotocash', // Name
			array('description' => __( 'Виджет знакомств Fotocash', 'text_domain' )), // @TODO change description
			array( 'id_base'			=> 'fotocash')
		);

		if (is_active_widget(false, false, $this->id_base)) {
			add_action('wp_enqueue_scripts', array( $this, 'init_css' ));
		}
	}

	/**
	 * Front-end display of widget.
	 *
	 * @see WP_Widget::widget()
	 *
	 * @param array $args     Widget arguments.
	 * @param array $instance Saved values from database.
	 */
	public function widget( $args, $instance ) {
		wp_register_script($this->id_base.'-geo', $this->_exteranl_api.'?act=set_city&type=wordpress', array(), null, true);
		wp_enqueue_script($this->id_base.'-geo');

		extract($args);
		$title = apply_filters('widget_title', $instance['title']);

		$instance['url'] = $this->_tds_url;
		$instance['promo_id'] = $this->_tds_promo;

		$gender = $this->_fields['gender']['values'];
		$values = array();
		foreach($this->_fields as $key => $info) {
			if (isset($info['values']))
			$values[$key] = $info['values'];
		}

		echo $before_widget;
		if (!empty($title) && empty($instance['color_title']))
			echo $before_title . $title . $after_title;

		$static_is_inited = (bool) self::$_initied;
		++self::$_initied;

		if (!$instance['city']) {
			//wp_enqueue_style($this->id_base, );
		}

		include plugin_dir_path( __FILE__ ) . 'widget.php';
		echo $after_widget;
	}

	public function init_css() {
		wp_register_style($this->id_base, plugins_url(basename(dirname(__FILE__)) . '/css/widget.css'));
		wp_enqueue_style($this->id_base);
	}

	/**
	 * Sanitize widget form values as they are saved.
	 *
	 * @see WP_Widget::update()
	 *
	 * @param array $new_instance Values just sent to be saved.
	 * @param array $old_instance Previously saved values from database.
	 *
	 * @return array Updated safe values to be saved.
	 */
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		foreach(array_keys($this->_fields) as $key) {
			$instance[$key] = isset($new_instance[$key]) ? $new_instance[$key] : null;
		}
		return $instance;
	}

	/**
	 * Back-end widget form.
	 *
	 * @see WP_Widget::form()
	 *
	 * @param array $instance Previously saved values from database.
	 */
	public function form( $instance ) {
		$title = isset($instance[ 'title' ]) ? $instance[ 'title' ] : __( 'Быстрые знакомства', 'text_domain' );
		$fields = array();
		foreach($this->_fields as $key => $info) {
			$fields[$key] = array(
				'id' => $key,
				'label' => __($info['label'], 'text_domain'),
				'is_valid' => true,
				'value' => (isset($instance[$key]) ? $instance[$key] : (isset($info['default']) ? __($info['default'], 'text_domain') :null)),
				'required' => !empty($info['required']),
				'tip' => empty($info['tip']) ? '' : __($info['tip'], 'text_domain'),
			);
			if (isset($info['values'])) {
				$fields[$key]['is_valid'] = isset($info['values'][$fields[$key]['value']]);
				$fields[$key]['values'] = $info['values'];
			} elseif(isset($info['validator'])) {
				$fields[$key]['is_valid'] = call_user_func(array($this, $info['validator']), $instance, $key);
			}
		}
		include plugin_dir_path( __FILE__ ) . 'form.php';
	}

	/**
	 * Validate ref_id param
	 *
	 * @param array $instance Previously saved values from database.
	 * @param string $key.
	 */
	private static function valid_ref_id($instance, $key) {
		return (!empty($instance[$key]) && is_numeric($instance[$key]) && $instance[$key]>1000000);
	}

	/**
	 * Validate age param
	 *
	 * @param array $instance Previously saved values from database.
	 * @param string $key.
	 */
	private static function valid_age($instance, $key) {
		return (empty($instance[$key]) || (is_numeric($instance[$key]) && $instance[$key]>15 && $instance[$key]<61));
	}
	/**
	 * Validate sub_id param
	 *
	 * @param array $instance Previously saved values from database.
	 * @param string $key.
	 */
	private static function valid_sub_id($instance, $key) {
		return (empty($instance[$key]) || strlen($instance[$key]<200));
	}

	/**
	 * Validate color field
	 *
	 * @param array $instance Previously saved values from database.
	 * @param string $key.
	 */
	private static function valid_color($instance, $key) {
		return (empty($instance[$key]) || preg_match( '/^#([0-9a-f]{3}|[0-9a-f]{6})$/i', $instance[$key]));
	}

} // class Fotocash_Widget

add_action( 'widgets_init', create_function( '', 'register_widget( \'fotocash_widget\' );' ) );